
/*  A Bison parser, made from preproc.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	SQL_START	258
#define	SQL_SEMI	259
#define	SQL_STRING	260
#define	SQL_INTO	261
#define	SQL_BEGIN	262
#define	SQL_END	263
#define	SQL_DECLARE	264
#define	SQL_SECTION	265
#define	SQL_INCLUDE	266
#define	SQL_CONNECT	267
#define	SQL_OPEN	268
#define	SQL_COMMIT	269
#define	SQL_ROLLBACK	270
#define	S_SYMBOL	271
#define	S_LENGTH	272
#define	S_ANYTHING	273
#define	S_VARCHAR	274
#define	S_VARCHAR2	275
#define	S_EXTERN	276
#define	S_STATIC	277
#define	S_UNSIGNED	278
#define	S_SIGNED	279
#define	S_LONG	280
#define	S_SHORT	281
#define	S_INT	282
#define	S_CHAR	283
#define	S_FLOAT	284
#define	S_DOUBLE	285
#define	S_BOOL	286

#line 2 "preproc.y"

#include <stdio.h>
#include <string.h>
#include "type.h"

void yyerror(char *);
extern FILE * yyout;
extern char * yytext;
extern int yylineno;
extern int yyleng;

/*
 * Variables containing simple states.
 */
int	debugging = 0;

/*
 * Handle the filename and line numbering.
 */
char * input_filename = NULL;

void
output_line_number()
{
    if (input_filename)
	fprintf(yyout, "\n#line %d \"%s\"\n", yylineno, input_filename);
}


/*
 * Handling of the variables.
 */
/* Since we don't want to keep track of where the functions end we just
 * have a list of functions that we search in, most reasently defined
 * function. This won't work if we use block scope for variables with the
 * same name but different types but in all other cases the c-compiler will
 * signal an error (hopefully).
 *
 * This list is leaked on program exit. This is because I don't think it is
 * important enough to spend the extra ten minutes to write the function that
 * deletes it. It would be another thing if I would have written in C++.
 */
/* This is a linked list of the variable names and types. */
struct variable
{
    char * name;
    struct ECPGtype * type;
    struct variable * next;
};

static struct variable * allvariables = NULL;

struct variable *
find_variable(char * name)
{
    struct variable * p;

    for (p = allvariables; p; p = p->next)
    {
        if (strcmp(p->name, name) == 0)
	    return p;
    }

    {
	char * errorstring = (char *) malloc(strlen(name) + 100);

	sprintf(errorstring, "The variabel :%s is not declared.", name);

	yyerror(errorstring);
    }
    return NULL;
}


void
new_variable(const char * name, struct ECPGtype * type)
{
    struct variable * p = (struct variable*) malloc(sizeof(struct variable));

    p->name = strdup(name);
    p->type = type;

    p->next = allvariables;
    allvariables = p;
}


/*
 * Here is the variables that need to be handled on every request.
 * These are of two kinds: input and output.
 * I will make two lists for them.
 */
struct arguments {
    struct variable * variable;
    struct arguments * next;
};


static struct arguments * argsinsert = NULL;
static struct arguments * argsresult = NULL;

void
reset_variables()
{
    argsinsert = NULL;
    argsresult = NULL;
}


/* Add a variable to a request. */
void
add_variable(struct arguments ** list, struct variable * var)
{
    struct arguments * p = (struct arguments *)malloc(sizeof(struct arguments));
    p->variable = var;
    p->next = *list;
    *list = p;
}


/* Dump out a list of all the variable on this list.
   This is a recursive function that works from the end of the list and
   deletes the list as we go on.
 */
void
dump_variables(struct arguments * list)
{
    if (list == NULL)
    {
        return;
    }

    /* The list is build up from the beginning so lets first dump the
       end of the list:
     */

    dump_variables(list->next);

    /* Then the current element. */
    ECPGdump_a_type(stdout, list->variable->name, list->variable->type);

    /* Then release the list element. */
    free(list);
}


#line 149 "preproc.y"
typedef union {
    int				tagname;
    struct ECPGtemp_type	type;
    char *			symbolname;
    int				indexsize;
    enum ECPGttype		type_enum;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		121
#define	YYFLAG		-32768
#define	YYNTBASE	37

#define YYTRANSLATE(x) ((unsigned)(x) <= 286 ? yytranslate[x] : 74)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    35,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    36,    34,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    32,     2,    33,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,    10,    12,    14,    16,    18,
    20,    22,    26,    32,    38,    39,    42,    45,    47,    50,
    52,    54,    58,    60,    62,    65,    67,    70,    72,    75,
    77,    80,    82,    85,    87,    89,    91,    93,    95,    96,
   100,   102,   103,   109,   111,   114,   115,   116,   123,   128,
   129,   132,   136,   140,   141,   146,   148,   151,   154,   157,
   159,   162,   165,   170,   172,   174,   176,   178,   180,   182,
   184,   186,   188,   190,   192,   194,   196,   198,   200,   202,
   204,   206,   208,   210,   212,   214,   216,   218,   220,   222
};

static const short yyrhs[] = {    38,
     0,     0,    38,    39,     0,    40,     0,    55,     0,    58,
     0,    61,     0,    63,     0,    64,     0,    65,     0,    70,
     0,    41,    43,    42,     0,     3,     7,     9,    10,     4,
     0,     3,     8,     9,    10,     4,     0,     0,    43,    44,
     0,    46,    34,     0,    16,     0,    52,    47,     0,    48,
     0,    50,     0,    49,    45,    53,     0,    19,     0,    20,
     0,    51,    45,     0,    28,     0,    23,    28,     0,    26,
     0,    23,    26,     0,    27,     0,    23,    27,     0,    25,
     0,    23,    25,     0,    29,     0,    30,     0,    31,     0,
    21,     0,    22,     0,     0,    32,    54,    33,     0,    17,
     0,     0,     3,    11,    56,    57,     4,     0,    70,     0,
    57,    70,     0,     0,     0,     3,    12,    59,     5,    60,
     4,     0,     3,    13,    62,     4,     0,     0,    62,    72,
     0,     3,    14,     4,     0,     3,    15,     4,     0,     0,
     3,    66,    67,     4,     0,    68,     0,    67,    68,     0,
    36,    45,     0,     6,    69,     0,    72,     0,     6,    72,
     0,    36,    45,     0,    69,    35,    36,    45,     0,    71,
     0,    73,     0,     6,     0,    34,     0,    73,     0,    17,
     0,    19,     0,    20,     0,    25,     0,    26,     0,    27,
     0,    28,     0,    29,     0,    30,     0,    13,     0,    12,
     0,     5,     0,     7,     0,     8,     0,     9,     0,    10,
     0,    11,     0,    16,     0,    32,     0,    33,     0,    35,
     0,    18,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   178,   180,   181,   183,   184,   185,   186,   187,   188,   189,
   190,   192,   196,   200,   205,   206,   209,   215,   224,   225,
   226,   228,   234,   235,   237,   243,   244,   245,   246,   247,
   248,   249,   250,   251,   252,   253,   255,   256,   257,   259,
   263,   265,   266,   268,   269,   271,   272,   273,   276,   278,
   279,   282,   286,   291,   296,   306,   307,   309,   314,   315,
   320,   327,   330,   334,   338,   339,   340,   342,   344,   344,
   344,   345,   345,   345,   345,   345,   345,   346,   346,   347,
   348,   348,   349,   349,   350,   351,   352,   352,   352,   353
};

static const char * const yytname[] = {   "$","error","$illegal.","SQL_START",
"SQL_SEMI","SQL_STRING","SQL_INTO","SQL_BEGIN","SQL_END","SQL_DECLARE","SQL_SECTION",
"SQL_INCLUDE","SQL_CONNECT","SQL_OPEN","SQL_COMMIT","SQL_ROLLBACK","S_SYMBOL",
"S_LENGTH","S_ANYTHING","S_VARCHAR","S_VARCHAR2","S_EXTERN","S_STATIC","S_UNSIGNED",
"S_SIGNED","S_LONG","S_SHORT","S_INT","S_CHAR","S_FLOAT","S_DOUBLE","S_BOOL",
"'['","']'","';'","','","':'","prog","statements","statement","sqldeclaration",
"sql_startdeclare","sql_enddeclare","variable_declarations","variable_declaration",
"symbol","type","type_detailed","varchar_type","varchar_tag","simple_type","simple_tag",
"maybe_storage_clause","index","length","sqlinclude","@1","filename","sqlconnect",
"@2","@3","sqlopen","sqlgarbage","sqlcommit","sqlrollback","sqlstatement","@4",
"sqlstatement_words","sqlstatement_word","into_list","cthing","canything","sqlanything",
"both_anything",""
};
#endif

static const short yyr1[] = {     0,
    37,    38,    38,    39,    39,    39,    39,    39,    39,    39,
    39,    40,    41,    42,    43,    43,    44,    45,    46,    47,
    47,    48,    49,    49,    50,    51,    51,    51,    51,    51,
    51,    51,    51,    51,    51,    51,    52,    52,    52,    53,
    54,    56,    55,    57,    57,    59,    60,    58,    61,    62,
    62,    63,    64,    66,    65,    67,    67,    68,    68,    68,
    68,    69,    69,    70,    71,    71,    71,    72,    73,    73,
    73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
    73,    73,    73,    73,    73,    73,    73,    73,    73,    73
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     3,     5,     5,     0,     2,     2,     1,     2,     1,
     1,     3,     1,     1,     2,     1,     2,     1,     2,     1,
     2,     1,     2,     1,     1,     1,     1,     1,     0,     3,
     1,     0,     5,     1,     2,     0,     0,     6,     4,     0,
     2,     3,     3,     0,     4,     1,     2,     2,     2,     1,
     2,     2,     4,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1
};

static const short yydefact[] = {     2,
     1,    54,    80,    66,    81,    82,    83,    84,    85,    79,
    78,    86,    69,    90,    70,    71,    72,    73,    74,    75,
    76,    77,    87,    88,    67,    89,     3,     4,    15,     5,
     6,     7,     8,     9,    10,    11,    64,    65,     0,    42,
    46,    50,     0,     0,     0,    39,     0,     0,     0,     0,
    52,    53,     0,     0,     0,    56,    60,    68,     0,    37,
    38,    12,    16,     0,     0,     0,     0,    44,    47,    49,
    51,     0,    59,    61,    18,    58,    55,    57,     0,    17,
    23,    24,     0,    32,    28,    30,    26,    34,    35,    36,
    19,    20,     0,    21,     0,    13,    43,    45,     0,    62,
     0,     0,    33,    29,    31,    27,     0,    25,    48,     0,
     0,     0,    22,    63,    14,    41,     0,    40,     0,     0,
     0
};

static const short yydefgoto[] = {   119,
     1,    27,    28,    29,    62,    46,    63,    76,    64,    91,
    92,    93,    94,    95,    65,   113,   117,    30,    48,    67,
    31,    49,    99,    32,    50,    33,    34,    35,    45,    55,
    56,    73,    36,    37,    57,    58
};

static const short yypact[] = {-32768,
     0,   244,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -5,-32768,
-32768,-32768,    10,    11,   108,    20,    21,   202,    31,   141,
-32768,-32768,   170,    22,    44,-32768,-32768,-32768,    50,-32768,
-32768,-32768,-32768,    25,   219,    61,    77,-32768,-32768,-32768,
-32768,    22,    32,-32768,-32768,-32768,-32768,-32768,    59,-32768,
-32768,-32768,    18,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    22,-32768,    22,-32768,-32768,-32768,    71,-32768,
    42,    81,-32768,-32768,-32768,-32768,    60,-32768,-32768,    22,
    94,    82,-32768,-32768,-32768,-32768,    67,-32768,   101,   122,
-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -71,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    53,-32768,   -46,-32768,   -13,    -1
};


#define	YYLAST		259


static const short yytable[] = {    38,
   100,    68,     2,    47,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    51,    52,    12,    13,    14,    15,    16,
    98,   107,    59,   108,    17,    18,    19,    20,    21,    22,
    66,    23,    24,    25,    26,    69,    71,    75,   114,    74,
    60,    61,   103,   104,   105,   106,    38,    77,     3,    53,
     5,     6,     7,     8,     9,    10,    11,    79,    80,    12,
    13,    14,    15,    16,    96,    38,   101,   102,    17,    18,
    19,    20,    21,    22,   109,    23,    24,   110,    26,    54,
    97,     3,     4,     5,     6,     7,     8,     9,    10,    11,
   111,   112,    12,    13,    14,    15,    16,   115,   116,   118,
   120,    17,    18,    19,    20,    21,    22,    78,    23,    24,
    25,    26,     3,    53,     5,     6,     7,     8,     9,    10,
    11,   121,     0,    12,    13,    14,    15,    16,     0,     0,
     0,     0,    17,    18,    19,    20,    21,    22,     0,    23,
    24,     0,    26,    54,    70,     3,     0,     5,     6,     7,
     8,     9,    10,    11,     0,     0,    12,    13,    14,    15,
    16,     0,     0,     0,     0,    17,    18,    19,    20,    21,
    22,     0,    23,    24,     3,    26,     5,     6,     7,     8,
     9,    10,    11,     0,     0,    12,    13,    14,    15,    16,
     0,     0,     0,     0,    17,    18,    19,    20,    21,    22,
     0,    23,    24,     0,    26,    72,     3,     4,     5,     6,
     7,     8,     9,    10,    11,     0,     0,    12,    13,    14,
    15,    16,     0,     0,     0,     0,    17,    18,    19,    20,
    21,    22,     0,    23,    24,    25,    26,    81,    82,     0,
     0,    83,     0,    84,    85,    86,    87,    88,    89,    90,
    39,     0,     0,     0,    40,    41,    42,    43,    44
};

static const short yycheck[] = {     1,
    72,    48,     3,     9,     5,     6,     7,     8,     9,    10,
    11,    12,    13,     4,     4,    16,    17,    18,    19,    20,
    67,    93,     3,    95,    25,    26,    27,    28,    29,    30,
    10,    32,    33,    34,    35,     5,    50,    16,   110,    53,
    21,    22,    25,    26,    27,    28,    48,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,     8,    34,    16,
    17,    18,    19,    20,     4,    67,    35,     9,    25,    26,
    27,    28,    29,    30,     4,    32,    33,    36,    35,    36,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    10,    32,    16,    17,    18,    19,    20,     4,    17,    33,
     0,    25,    26,    27,    28,    29,    30,    55,    32,    33,
    34,    35,     5,     6,     7,     8,     9,    10,    11,    12,
    13,     0,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    25,    26,    27,    28,    29,    30,    -1,    32,
    33,    -1,    35,    36,     4,     5,    -1,     7,     8,     9,
    10,    11,    12,    13,    -1,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    25,    26,    27,    28,    29,
    30,    -1,    32,    33,     5,    35,     7,     8,     9,    10,
    11,    12,    13,    -1,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    25,    26,    27,    28,    29,    30,
    -1,    32,    33,    -1,    35,    36,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    -1,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    25,    26,    27,    28,
    29,    30,    -1,    32,    33,    34,    35,    19,    20,    -1,
    -1,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
     7,    -1,    -1,    -1,    11,    12,    13,    14,    15
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1 	/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 13:
#line 196 "preproc.y"
{
    fprintf(yyout, "/* exec sql begin declare section */\n"); 
    output_line_number();
;
    break;}
case 14:
#line 200 "preproc.y"
{
    fprintf(yyout, "/* exec sql end declare section */\n"); 
    output_line_number();
;
    break;}
case 17:
#line 209 "preproc.y"
{ 
    new_variable(yyvsp[-1].type.name, yyvsp[-1].type.typ);
    free(yyvsp[-1].type.name);
    fprintf(yyout, ";"); 
;
    break;}
case 18:
#line 215 "preproc.y"
{ 
    char * name = (char *)malloc(yyleng + 1);

    strncpy(name, yytext, yyleng);
    name[yyleng] = '\0';

    yyval.symbolname = name;
;
    break;}
case 19:
#line 224 "preproc.y"
{ yyval.type = yyvsp[0].type; ;
    break;}
case 20:
#line 225 "preproc.y"
{ yyval.type = yyvsp[0].type; ;
    break;}
case 21:
#line 226 "preproc.y"
{ yyval.type = yyvsp[0].type; ;
    break;}
case 22:
#line 228 "preproc.y"
{
    fprintf(yyout, "struct varchar_%s { int len; char arr[%d]; } %s", yyvsp[-1].symbolname, yyvsp[0].indexsize, yyvsp[-1].symbolname);
    yyval.type.name = yyvsp[-1].symbolname;
    yyval.type.typ = ECPGmake_varchar_type(ECPGt_varchar, yyvsp[0].indexsize);
;
    break;}
case 23:
#line 234 "preproc.y"
{ yyval.tagname = yyvsp[0].tagname; ;
    break;}
case 24:
#line 235 "preproc.y"
{ yyval.tagname = yyvsp[0].tagname; ;
    break;}
case 25:
#line 237 "preproc.y"
{
    fprintf(yyout, "%s %s", ECPGtype_name(yyvsp[-1].type_enum), yyvsp[0].symbolname);
    yyval.type.name = yyvsp[0].symbolname;
    yyval.type.typ = ECPGmake_simple_type(yyvsp[-1].type_enum);
;
    break;}
case 26:
#line 243 "preproc.y"
{ yyval.type_enum = ECPGt_char; ;
    break;}
case 27:
#line 244 "preproc.y"
{ yyval.type_enum = ECPGt_unsigned_char; ;
    break;}
case 28:
#line 245 "preproc.y"
{ yyval.type_enum = ECPGt_short; ;
    break;}
case 29:
#line 246 "preproc.y"
{ yyval.type_enum = ECPGt_unsigned_short; ;
    break;}
case 30:
#line 247 "preproc.y"
{ yyval.type_enum = ECPGt_int; ;
    break;}
case 31:
#line 248 "preproc.y"
{ yyval.type_enum = ECPGt_unsigned_int; ;
    break;}
case 32:
#line 249 "preproc.y"
{ yyval.type_enum = ECPGt_long; ;
    break;}
case 33:
#line 250 "preproc.y"
{ yyval.type_enum = ECPGt_unsigned_long; ;
    break;}
case 34:
#line 251 "preproc.y"
{ yyval.type_enum = ECPGt_float; ;
    break;}
case 35:
#line 252 "preproc.y"
{ yyval.type_enum = ECPGt_double; ;
    break;}
case 36:
#line 253 "preproc.y"
{ yyval.type_enum = ECPGt_bool; ;
    break;}
case 37:
#line 255 "preproc.y"
{ fwrite(yytext, yyleng, 1, yyout); ;
    break;}
case 38:
#line 256 "preproc.y"
{ fwrite(yytext, yyleng, 1, yyout); ;
    break;}
case 39:
#line 257 "preproc.y"
{ ;
    break;}
case 40:
#line 259 "preproc.y"
{
    yyval.indexsize = yyvsp[-1].indexsize; 
;
    break;}
case 41:
#line 263 "preproc.y"
{ yyval.indexsize = atoi(yytext); ;
    break;}
case 42:
#line 265 "preproc.y"
{ fprintf(yyout, "#include \""); ;
    break;}
case 43:
#line 266 "preproc.y"
{ fprintf(yyout, ".h\""); output_line_number(); ;
    break;}
case 46:
#line 271 "preproc.y"
{ fprintf(yyout, "ECPGconnect(\""); ;
    break;}
case 47:
#line 272 "preproc.y"
{ fwrite(yytext + 1, yyleng - 2, 1, yyout); ;
    break;}
case 48:
#line 273 "preproc.y"
{ fprintf(yyout, "\");"); output_line_number(); ;
    break;}
case 49:
#line 276 "preproc.y"
{ output_line_number(); ;
    break;}
case 52:
#line 282 "preproc.y"
{
    fprintf(yyout, "ECPGcommit(__LINE__);"); 
    output_line_number();
;
    break;}
case 53:
#line 286 "preproc.y"
{
    fprintf(yyout, "ECPGrollback(__LINE__);");
    output_line_number();
;
    break;}
case 54:
#line 291 "preproc.y"
{ /* Reset stack */
    reset_variables();
    fprintf(yyout, "ECPGdo(__LINE__, \"");
;
    break;}
case 55:
#line 296 "preproc.y"
{  
    /* Dump */
    fprintf(yyout, "\", ");		   
    dump_variables(argsinsert);
    fprintf(yyout, "ECPGt_EOIT, ");
    dump_variables(argsresult);
    fprintf(yyout, "ECPGt_EORT );");
    output_line_number();
;
    break;}
case 58:
#line 310 "preproc.y"
{
		      add_variable(&argsinsert, find_variable(yyvsp[0].symbolname));
		      fprintf(yyout, " ;; ");
		  ;
    break;}
case 59:
#line 314 "preproc.y"
{ ;
    break;}
case 60:
#line 316 "preproc.y"
{ 
		      fwrite(yytext, yyleng, 1, yyout);
		      fwrite(" ", 1, 1, yyout);
		  ;
    break;}
case 61:
#line 321 "preproc.y"
{
		      fprintf(yyout, " into ");
		      fwrite(yytext, yyleng, 1, yyout);
		      fwrite(" ", 1, 1, yyout);
		  ;
    break;}
case 62:
#line 327 "preproc.y"
{
    add_variable(&argsresult, find_variable(yyvsp[0].symbolname)); 
;
    break;}
case 63:
#line 330 "preproc.y"
{
    add_variable(&argsresult, find_variable(yyvsp[0].symbolname)); 
;
    break;}
case 64:
#line 334 "preproc.y"
{
    fwrite(yytext, yyleng, 1, yyout);
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 355 "preproc.y"

void yyerror(char * error)
{
    fprintf(stderr, "%s\n", error);
    exit(1);
}


int
main(int argc, char *argv[0])
{
    FILE * input_file;

    debugging = 0;		/* An argument could turn debugging on. */

    if (argc != 2)
    {
	fprintf(stderr, "%s: Incorrect number of arguments.", argv[0]);
	fprintf(stderr, "%s: Usage:\n\t%s filename\n", argv[0], argv[0]);
	exit(2);
    }

    input_filename = argv[1];
    input_file = fopen(input_filename, "r");

    if (input_file == NULL)
    {
	perror("cannot open file");
	exit(1);
    }

    lex_init(input_file);
    fprintf(stdout, 
	    "/* These two include files are added by the preprocessor */\n"
            "#include <ecpgtype.h>\n"
	    "#include <ecpglib.h>\n"
	    "#line 1 \"%s\"\n", input_filename);
    yyparse();
}

